function u=HDFPasso(u,dt,dx,fu,a,sc)
%
% u, fu, a vettori, dt e dx scalari, sc variabile
% di controllo che sceglie l'algoritmo risolutivo
% Risoluzione dell'equazione 
%              u_t+f(u)_x=0, a=f'(u)
% tramite diversi schemi alle differenze finite.
% sc=1 metodo upwind
% sc=2 metodo Lax-Friedrichs
% sc=3 metodo leapfrog (con u=u^(n-1) e fu=f(u^n))
% sc=4 metodo Lax-Wendroff
%
lambda=dt/dx;
N=length(u);
switch sc
case 1
   al = (a(2:N-1)+a(1:N-2))/2; 
   ar = (a(2:N-1)+a(3:N))/2; 
   sl = (1+sign(al))/2;
   sr = (1-sign(ar))/2;
   u(2:N-1)=u(2:N-1)-lambda*(sl.*(fu(2:N-1)-fu(1:N-2))+sr.*(fu(3:N)-fu(2:N-1)));
case 2
   u(2:N-1)=0.5*(u(1:N-2)+u(3:N))-0.5*lambda*(fu(3:N)-fu(1:N-2));
case 3
   u(2:N-1)=u(2:N-1)-lambda*(fu(3:N)-fu(1:N-2));
case 4
   al = (a(2:N-1)+a(1:N-2))/2; 
   ar = (a(2:N-1)+a(3:N))/2; 
   u(2:N-1)=u(2:N-1)-0.5*lambda*(fu(3:N)-fu(1:N-2))+...
      0.5*lambda^2*(ar.*(fu(3:N)-fu(2:N-1))-al.*(fu(2:N-1)-fu(1:N-2)));
end
   