%     Script file: mdc.m (metodo delle caratteristiche)
%
% Lo script risolve l'equazione iperbolica 
%                  u_t + a(u)u_x = 0 
% con a(u)= costante, oppure a(u)=u, tramite il metodo 
% delle caratteristiche.
% Il dato iniziale e' definito dalla funzione z=dato(x,m).
% NOTA: Nel caso non lineare la soluzione ottenuta ha senso 
% solo per tempi piccoli nei quali le caratteristiche 
% non si intersecano.
%

close all;
clc;
clear all;
N = 40 ;
x0 = linspace(-5,5,N);
dx= 10 /(N-1);
n = 5 ;
m = input('Scegli il dato iniziale (1,2,3)  : ');
pb =input('Caso lineare o non lineare (1,2) : ');
if pb == 1
a = input('Valore della costante a          : ');
elseif pb==2
   a = dato(x0,m);
end
tf =input('Inserisci il tempo finale tf     : ');

t = linspace(0,tf,n);
u=dato(x0,m);
plot(x0,u,'b');
axis tight;
s=sprintf('Soluzione ai tempi t=%2.1f, %2.1f, %2.1f, %2.1f, %2.1f',...
   t(1),t(2),t(3),t(4),t(5));
title(s);
c = x0 ;
pause(.2);
axis manual;
hold on ;
for k=2:n
   x = x0 + a*t(k) ;
   c = [c;x];
   u=dato(x-a*t(k),m);
   plot(x,u,'b');
   pause(.2);
end   
hold off;
pause(1);
figure;
plot(c,t,'r',c,t,'ro');
title('Curve caratteristiche');















