%     Script file: mdf.m (metodi alle differenze finite)
%
% Lo script risolve l'equazione iperbolica 
%                  u_t + a(u)u_x = 0 
% con a(u)= costante, oppure a(u)=u, tramite diversi metodi 
% alle differenze finite.
% NOTA: a(u)=u fornisce la legge di conservazione u_t + f(u)_x=0
% con f(u)=u^2/2.
% Il dato iniziale e' definito dalla funzione z=dato(x,m).
%

close all;
clc;
clear all;
N = 100 ;
L=5;
disp('[1] Upwind');
disp('[2] Lax-Friedrichs');
disp('[3] Leapfrog');
disp('[4] Lax-Wendroff');
sc= input('Scegli il metodo numerico (1-4)  : ');
m = input('Scegli il dato iniziale (1,2,3)  : ');
pb =input('Caso lineare o non lineare (1,2) : ');
if pb == 1
   av = input('Valore della costante a          : ');
   a = av*ones(1,N);
end
tf =input('Inserisci il tempo finale tf     : ');
nu =input('Condizione CFL (0-1]             : ');      

x = linspace(-L,L,N);
u=dato(x,m);
if pb==2
   a = u;
end
um=min(u);
uM=max(u);
amax=max(abs(a));
dx= 2*L /(N-1);
dt = nu*dx/amax;
n=tf/dt;
if sc==3
   n=n-1;
end
tc=0;
plot(x,u,':bo');
s=sprintf('Soluzione metodo %d caso %d al tempo t=%f',sc,pb,tc);
title(s);
axis([-L L um-.1 uM+.1]);
pause(.2);

for k=1:n
   tc=tc+dt;
   if pb==1
      fu = a.* u ;
   elseif pb==2
      fu = u.^2 / 2 ;
   end   
   if sc==3 
      if k==1
         tc=tc+dt;
         un = u ;
         u = HDFPasso(u,dt,dx,fu,a,4);
         if pb==1
            fu = a.* u ;
         elseif pb==2
            fu = u.^2 / 2 ;
         end
      end
      u0=u;
      u = HDFPasso(un,dt,dx,fu,a,sc);
      un=u0;
   else
      u = HDFPasso(u,dt,dx,fu,a,sc);
   end
   if pb==2
      a=u;
   end
   plot(x,u,':bo');
   s=sprintf('Soluzione metodo %d caso %d al tempo t=%f',sc,pb,tc);
   title(s);
   axis([-L L um-.1 uM+.1]);
   pause(.2);
end   















